/*
 * Copyright (c) 2004-2016 Zementis, Inc.
 * Copyright (c) 2016-2017 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its 
 * subsidiaries and/or its affiliates and/or their licensors.
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your 
 * License Agreement with Software AG.
 */
package com.zementis.adapa.sample.loghandlers;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.zementis.adapa.extensions.ModelLogHandler;

/**
 *
 */
public class FileLogHandlerFactory implements ModelLogHandler.Factory {

    private final File outputLocation;

    private final List<ModelLogHandler> handlers = new ArrayList<ModelLogHandler>();

    /**
     * @param outputLocation
     */
    public FileLogHandlerFactory(File outputLocation) {
        this.outputLocation = outputLocation;
    }

    @Override
    public ModelLogHandler createModelLogHandler(String modelName, Map<String, Class<?>> modelFields) {
        ModelLogHandler modelLogHandler = new FileLogHandler(modelName, modelFields, outputLocation);
        handlers.add(modelLogHandler);
        return modelLogHandler;
    }

    public void flush() {
        for (ModelLogHandler modelLogHandler : handlers) {
            modelLogHandler.flush();
        }
    }
}
